#!/usr/local/bin/bash
if [ $# -ne 1 ]
then
    echo 
    echo "Usage: ./`basename $0` <bin>"
    echo 
    echo "Dumps opcodes from assembled and linked bin,"
    echo "then perl -e 'print <OPCODES>;' to sc.bin."
    echo
    echo "Example: "
    echo "as code.s -o code.o"
    echo "ld code.o -o code"
    echo "./`basename $0` code"
    echo
    exit 65
fi

SC=`objdump -d ./${1} | grep -v 'file' |cut -d: -f2|cut -f1-7 -d' '|tr -s ' '| \
tr '\t' ' '|sed 's/ $//g'|sed 's/ /\\\\x/g'|tr -d '\n'|sed 's/^/"/'|sed 's/$/"/g'`

PCMD="perl -e 'print ${SC};' > sc.bin"
eval ${PCMD}
